package assignment;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Random;
import java.util.Calendar;

/**
 * Title:        Home work #4
 * Description:  Fitts law measure
 * Copyright:    Copyright (c) 2002
 * Company:      University of Maryland
 * @author Daniel Camara
 * @version 1.0
 */
public class FittsLaw extends JFrame implements MouseListener {
  public static final String MESSAGE = " Messages:";
  public static final int CLICK_NUMBER = 10;
  public static final int GREATEST_DIFFICULT_INDEX = 6;
  public static final int FIRST_DIFFICULT_INDEX = 2;
  public static final String INDEX_DIFFICULTY_MESSAGE = "   Index of Difficulty ";

  Random random;
  boolean packFrame = false;
  BorderLayout borderLayout = new BorderLayout();
  FittsLawCanvas canvas;
  FileWriter fw;

  int clicks = 0; // number of valid clicks received
  boolean left = true; // if is the left rectanle tuurnd of receive a click
  int rectangleA[] = new int[4]; // the A square (left most)
  int rectangleB[] = new int[4]; // the B square (right most)
  int experiment =1; // number of the experiment
  int indexOfDifficulty = FIRST_DIFFICULT_INDEX; // index of difficulty of the experiment

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel message = new JLabel();
  JLabel experimentNumber = new JLabel();
  JLabel dificultyLevelMessage = new JLabel();

  double[][] statistics;
  double[][] errors;
  int[] arrayPosition;

  /**Construct the application*/
  public FittsLaw() {
   // JFrame frame = new JFrame();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      pack();
    }
    else {
      validate();
    }

    // I am using the same seed to make sure that the experiments will
    // be the same to every subject. Eventhough the progam is prepared to
    // run for more than one subject, to each one the program need to
    // be called again if you want the same experiments to each subject.
    random = new Random(12354);

    // Sets the frame size
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

    Dimension frameSize = new Dimension((int)(screenSize.width - (screenSize.width/8)),
                                        (int)(screenSize.height -(screenSize.height/8)));
    setSize(frameSize);
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }

    //Center the window to show it
    setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

    String fileName = "Fitts_"+Calendar.getInstance().getTime().getTime() + ".statistics";
    File f = new File(fileName);
    fw = null;

    try{
      if(f.exists())
         fw = new FileWriter(fileName, true); //File
      else
         fw = new FileWriter(fileName, false); //File
      }catch(Exception e){
        e.printStackTrace();
      }

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    // ad the mouse events listner
    addMouseListener(this);
    canvas.validate();
    canvas.setVisible(true);
    setVisible(true);
    this.getContentPane().setVisible(true);

    // calculates the first positions to the squares
    calculateNewPositions(FIRST_DIFFICULT_INDEX);

    // create the statistics variables
    createStatisticsVariables();

 }

  /**
   * Init interface variables
   */
  private void jbInit() throws Exception {

    setTitle("Fitts Law experiment");

    // the message bar
    message.setBackground(new Color(193, 233, 222));
    message.setFont(new java.awt.Font("SansSerif", 1, 17));
    message.setForeground(new Color(91, 159, 102));
    message.setText(MESSAGE + "       ");
    message.setVisible(true);
    message.setHorizontalAlignment(SwingConstants.LEFT);

    dificultyLevelMessage.setBackground(new Color(193, 233, 222));
    dificultyLevelMessage.setFont(new java.awt.Font("SansSerif", 1, 20));
    dificultyLevelMessage.setForeground(new Color(91, 159, 216));
    dificultyLevelMessage.setText(INDEX_DIFFICULTY_MESSAGE);
    dificultyLevelMessage.setVisible(true);
    dificultyLevelMessage.setHorizontalAlignment(SwingConstants.CENTER);

    experimentNumber.setBackground(new Color(193, 233, 222));
    experimentNumber.setFont(new java.awt.Font("SansSerif", 1, 25));
    experimentNumber.setForeground(new Color(91, 159, 102));
    experimentNumber.setText(" ");
    experimentNumber.setVisible(true);

    //canvas
    canvas = new FittsLawCanvas();
    canvas.addMouseListener(this);
    canvas.validate();
    canvas.setVisible(true);

    this.getContentPane().setBackground(Color.white);
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(borderLayout2);
    jPanel1.setBackground(new Color(255, 228, 216));
    jPanel1.setFont(new java.awt.Font("SansSerif", 1, 25));
    jPanel1.setForeground(new Color(74, 176, 125));
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.add(message, BorderLayout.WEST);
    jPanel1.add(experimentNumber, BorderLayout.EAST);
    jPanel1.add(dificultyLevelMessage, BorderLayout.CENTER);

    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
   // this.getContentPane().add(canvas, BorderLayout.CENTER);

   this.getContentPane().add(canvas, BorderLayout.CENTER);
  }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      try{
        fw.close();
      }catch(Exception ee){}

      System.exit(0);
    }

  }


//This must be implemented because this applet is registered as a MouseListener.
//However, a "blank" implementation will do just fine
public void mouseClicked(MouseEvent e){
}
public void mouseEntered(MouseEvent e){
}
public void mouseExited(MouseEvent e){
}
public void mouseReleased(MouseEvent e){
}

/**
 * We implement the entire program inside the mouse pressed to be sure that th
 * event would ne captured.  Click do not contemple drag events.  If the user
 * inadvertidly clic and push the mouse the method mouseClicked is not called.
 */
public void mousePressed(MouseEvent e){

  if(clicks==0){
    experimentNumber.setText(experiment + " of 15 ");
    dificultyLevelMessage.setText(INDEX_DIFFICULTY_MESSAGE + indexOfDifficulty);
    clicks = CLICK_NUMBER;
    canvas.setRectangleA(rectangleA[0],rectangleA[1],rectangleA[2],rectangleA[3]);
    canvas.setRectangleB(rectangleB[0],rectangleB[1],rectangleB[2],rectangleB[3]);
    canvas.setMessage1(null);
    canvas.setMessage2(null);
    canvas.repaint();
  }

  if(left){
    if(verifyClick(rectangleA[0], rectangleA[1],
                   rectangleA[0] + rectangleA[2], rectangleA[1] + rectangleA[3],
                   e.getX(), e.getY())){
      clicks--;
      left = false;

      // stores the positions
      statistics[indexOfDifficulty-2][arrayPosition[indexOfDifficulty-2]++] =
      Calendar.getInstance().getTime().getTime();
      canvas.setSide(canvas.RIGHT);
      canvas.repaint();

    } else {
      System.out.println("Missed Click"  + e.getX() + "," + e.getY());
      System.out.println("BOX "  + rectangleA[0] + ","+ rectangleA[1] +"  "+
                   (rectangleA[0] + rectangleA[2]) +"," + (rectangleA[1] + rectangleA[3]));
      errors[experiment][clicks]+=1;
    }
  }else{
    if(verifyClick(rectangleB[0], rectangleB[1],
                   rectangleB[0] + rectangleB[2], rectangleB[1] + rectangleB[3],
                   e.getX(), e.getY())){
      clicks--;
      left = true;

      // stores the positions
      statistics[indexOfDifficulty-2][arrayPosition[indexOfDifficulty-2]++] =
      Calendar.getInstance().getTime().getTime();
      canvas.setSide(canvas.LEFT);
      canvas.repaint();
    } else {
      System.out.println("Missed Click "  + e.getX() + "," + e.getY());
      System.out.println("Square " + rectangleB[0] + ","+ rectangleB[1] +"  "+
                   (rectangleB[0] + rectangleB[2]) +"," + (rectangleB[1] + rectangleB[3]));
      errors[experiment][clicks]+=1;
    }

  }
  message.setText(MESSAGE + "(" + e.getX()+ "," + e.getY()+")  Missing: " + clicks);

  // if arrived at the end of this trial
  if(clicks==0){
    if (experiment != 15){
      experiment++;

      canvas.setMessage1("Experiment " + experiment + " of 15");
    } else{
      canvas.setMessage1("The experiment is over thanks.");
      canvas.setMessage2("If you want to run another experimetn just click on the screen");
      computeStatisticalData();
      createStatisticsVariables();
      experiment =1; // number of the experiment
      canvas.setSide(canvas.LEFT);
   }
      canvas.repaint();

      // manage the index of difficulty of the next experiment
      indexOfDifficulty++;
      indexOfDifficulty = (indexOfDifficulty > GREATEST_DIFFICULT_INDEX)?
                              FIRST_DIFFICULT_INDEX : indexOfDifficulty;

      // this is here for performance purposes if this calculation was in the
      // first part, what is more natural, we would calculate the new squares
      // after the click to change experiments.  In this way we will calculate
      // while the user thinks in click, so we give more time to our function
      // find the new values
      calculateNewPositions(indexOfDifficulty);
  }
}



/**
 * This function calculates the expected sizes and distances to the next
 * experiment, based on the expected dificulty index that is passed as paramenter
 * to the function. The Fitts law formula is:
 *
 *      indexOfDifficulty=log2(2D/W)
 *      where:
 *          D = Distance between the squares
 *          W = Width of the square
 *          indexOfDifficulty = index of difuculty of the experiment
 *
 *  We will use this formula to find automatically feazible index of difficulties
 *  in the screen size.
 *
 *  We will fix the square size randomically,  that is easier to do in a
 *  reazonable range, and then we will find the distance between the squares
 *  on the screen.  The only restriction here is that both squares must
 *  apear completely on the screen.
 *
 *  The formula used to find the new square sizes is:
 *
 *      D = W * 2^(indexOfDifficulty-1)
 *      Where:
 *          D = Distance between the squares
 *          W = Width of the square
 *          indexOfDifficulty = index of difuculty of the next experiment
 *
 * @param indexOfDifficuty - the index of difuculty to do the experiment
 *
 * @return boolean - true if found values and false otherwaise
 */
 private boolean calculateNewPositions (int indexOfDifficulty){

    if (indexOfDifficulty < 1)
      return false;

    int w = 100; // width (initialized just to avoisd compiler error)
    int d = 100; //distance (initialized just to avoisd compiler error)
    int maxSize = canvas.getWidth();

    // calculate a reazonable guess being the half of the screen leting one
    // space to separete the squares
    int reasonableGuess = ((maxSize/2) - 40) ;

    boolean dontHaveSolution = true;

    // while do not found a feazeble solution
    while(dontHaveSolution){

      // Guess a value to the sqares width
      // I insert 10 to guarantee that the value will never be 0
      w = random.nextInt(reasonableGuess)+20;

      // Calculate the distance between the squares
      d = (int)(w * Math.pow(2,indexOfDifficulty-1));

      // verify if the two squares fits on the screen
      // if they fit we have a solution
      if ((2*w+d) <= maxSize)
        dontHaveSolution = false;
    }

    try{
      fw.write(w+":"+d+"\n");
    }catch(Exception e){e.printStackTrace();}
    // calculates squares values
    int y = (int)(canvas.getHeight()/2) - (w/2);

    // just to avoid any problem, the fitts low observe the width any way.
    if(y<0)
      y=0;

    // For the first square, the first corner is half of the screen
    // minus half of the distance between the squares minus the square width
    rectangleA[0] = (int)(maxSize/2) - (d/2) - w;
    rectangleA[1] = y;
    rectangleA[2] = w;
    rectangleA[3] = w;

    // For the second square, the first corner is half of the screen
    // plus half of the distance between the squares
    rectangleB[0] = (int)(maxSize/2) + (d/2);
    rectangleB[1] = y;
    rectangleB[2] = w;
    rectangleB[3] = w;

   return true;
 }

 /**
  * Computes the statistical data and writes it on the statistics file
  */
 private void computeStatisticalData(){

    try{
      for(int i = FIRST_DIFFICULT_INDEX; i<=GREATEST_DIFFICULT_INDEX; i++){
        fw.write("\nIndex Level " + i + "\n");
        for(int j = 0; j<29; j++){

          // arrived to the end of one trial
          if((j!=0)&&((j+1)%10)==0){
            j++;
            fw.write("\n");
          }

          fw.write( (statistics[i-FIRST_DIFFICULT_INDEX][j+1] -
                     statistics[i-FIRST_DIFFICULT_INDEX][j]) + ":");

        }
      }

      fw.write("\nErrors \n");
      for(int i = 0; i<=15; i++){
        for(int j = 0; j<10; j++){
          fw.write(errors[i][j]+ ":");
        }
        fw.write("\n");
      }

      // flushes the values to the disk
      fw.flush();
    }catch(Exception e){}
 }

/**
 * Verifies if the click point is inside the expected boundaries.
 * @param x1 - The top left X point position
 * @param y1 - The top left Y point position
 * @param x2 - The right botton X point position
 * @param y2 - The right botton Y point position
 * @param px - The verified point X value
 * @param py - The verified point Y value
 */
  private boolean verifyClick(int x1,int y1,int x2,int y2,int px,int py){
    if(px>x1 && px<(x2+3))
      if(py>y1 && (py<y2+3))
        return true;
    return false;
  }


 /**
  * Create new statistics variables.
  */
 private void createStatisticsVariables(){
    // create the statistics variables
    statistics = new double[GREATEST_DIFFICULT_INDEX - FIRST_DIFFICULT_INDEX +1][32];
    arrayPosition = new int[GREATEST_DIFFICULT_INDEX - FIRST_DIFFICULT_INDEX +1];
    errors =  new double[16][12];
 }

 private void testProcedure(){
    for(int i=0; i<5;i++){
      int step = 1;
      for(int j=0; j<30;j++){
        if((j%10)==0)
          try{ Thread.sleep(400);}catch(Exception e){}

       try{ Thread.sleep(random.nextInt(300));}catch(Exception e){}

       statistics[i][j] = Calendar.getInstance().getTime().getTime();
      }
    computeStatisticalData();
    }
 }

  /**
   * Main method
   */
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    FittsLaw fittsLaw = new FittsLaw();
//    fittsLaw.testProcedure();
//    fittsLaw.createStatisticsVariables();
  }



}

