package assignment;
import java.awt.*;
import java.awt.font.*;
import java.awt.geom.Rectangle2D;

/**
 * Title:        Home work #3
 * Description:  Alarm clock
 * Copyright:    Copyright (c) 2002
 * Company:      University of Maryland
 * @author Daniel Camara
 * @version 1.0
 */

public class FittsLawCanvas extends Canvas {

  public final int LEFT = 0;
  public final int RIGHT = 1;

  int side = LEFT; // the side the gui should click right now
  boolean newExperiment;
  int xA;
  int yA;
  int widthA;
  int heightA;
  int xB;
  int yB;
  int widthB;
  int heightB;
  String message1;
  String message2;

  public FittsLawCanvas() {
    newExperiment = true;
    message1 = "Experiment 1 of 15";
    message2 = "Click to Start";
    this.setFont(new Font("Helvetica Bold", Font.BOLD, 22));
  }

   /**
   * Sets the side the user should click
   */
   public void setSide(int side){
    this.side = side;
   }

  /**
   * Sets if this is a new experiment or not
   */
   public void setNewExperiment(boolean newExperiment){
    this.newExperiment = newExperiment;
   }


  /**
   * Sets thhe first message
   */
   public void setMessage1(String message1){
    this.message1 = message1;
   }

  /**
   * Sets the second message
   */
   public void setMessage2(String message2){
    this.message2 = message2;
  }
  /**
   * The first rectangle people need to clic on
   *
   * @param dimension, the dimension of the box to draw.
   */
  public void setRectangleA(int x, int y, int width, int height){
      xA=x;
      yA=y;
      widthA=width;
      heightA=height;
  }

   /**
   * The second rectangle people need to clic on
   *
   * @param dimension, the dimension of the box to draw.
   */
  public void setRectangleB(int x, int y, int width, int height){
      xB=x;
      yB=y;
      widthB=width;
      heightB=height;
  }

      public synchronized void update( Graphics theGr ){
        paint(theGr);
      }

    /**
     * Draw the experiment space
     */
    public void paint(Graphics g) {
      Dimension dimension = getSize();


    if(message1!=null) {
      Graphics2D g2d = (Graphics2D)g;
      FontRenderContext fontRenderContext =
      g2d.getFontRenderContext();

      g.setColor(Color.white);
      g.fillRect(0,0,(int)dimension.getWidth(),(int)dimension.getHeight());
      g.setColor(Color.blue);
//      g.drawString(message1,(int)(dimension.getWidth()/2)-170, (int)(dimension.getHeight()/2)-19);
//      g.drawString(message2,(int)(dimension.getWidth()/2)-145, (int)(dimension.getHeight()/2)+15);
      Rectangle2D ret = g.getFont().getStringBounds(message1, fontRenderContext);
      g.drawString(message1,
                  (int)((dimension.getWidth()/2)-(ret.getWidth()/2)),
                  (int)(dimension.getHeight()/2)-19);

      if(message2!=null){
        ret = g.getFont().getStringBounds(message2, fontRenderContext);
        g.drawString(message2,
                    (int)((dimension.getWidth()/2)-(ret.getWidth()/2)),
                    (int)(dimension.getHeight()/2)+15);
      }
    }else{
          g.setColor(Color.white);
          g.fillRect(0,0,(int)dimension.getWidth(),(int)dimension.getHeight());
          // draws A
          g.setColor(Color.orange);
          g.fill3DRect(xA,yA,widthA,heightA,true);

          // draws B
          g.setColor(new Color(97, 176, 125));
          g.fill3DRect(xB,yB,widthB,heightB,true);
          g.setColor(Color.red);

          if(side == LEFT){
              g.drawRect(xA-1,yA-1,widthA+1,heightA+1);
              g.drawRect(xA-2,yA-2,widthA+3,heightA+3);
          }else{
               g.drawRect(xB-1,yB-1,widthB+1,heightB+1);
               g.drawRect(xB-2,yB-2,widthB+3,heightB+3);
            }
      }
      setVisible(true);
    }

  public static void main(String[] args) {
    FittsLawCanvas fittsLawCanvas1 = new FittsLawCanvas();
  }
}